#ifndef KROGUEQH_H
#define KROGUEQH_H
#include <kquickhelp.h>
#include <ktoolbar.h>
#include <qintdict.h>

class KStatusBar;

void krqhSetToolBar(KToolBar *);
void krqhSetStatusBar(KStatusBar *);
void krqhSetMoreButton(QWidget *);
void krqhSetMsgBar(QWidget *);
void krqhSetTlTakeOff(KToolBar *);
void krqhSetTlWear(KToolBar *);
void krqhSetTlLPutOn(KToolBar *);
void krqhSetTlRPutOn(KToolBar *);
void krqhSetTlLRemove(KToolBar *);
void krqhSetTlRRemove(KToolBar *);
void krqhRemoveTl(KToolBar *, int);
QString krqhGetMonsterInfo(int monid);
QString krqhGetTrapInfo(int trapid);
QString krqhGetDItemInfo(int whatx, int whaty);
QString krqhGetHungryInfo(void);

#define QHBUTTONID 100

struct KRQHSlot
{
  QObject *recv;
  const char *slot;
};

class KRQuickHelp:public KQuickHelp
{
  Q_OBJECT
public:
  KRQuickHelp() {sigDict.setAutoDelete(true);}
  ~KRQuickHelp() {}
  static const char *add(QWidget *, const char *);
  static void remove(QWidget *);
  static void addSig(QWidget *w, const char *slot);
  static void addSig(QWidget *w, QObject *rec, const char *slot);
  static const char *helpForWidget(QWidget *);
  static KRQHSlot *slotForWidget(QWidget *);
  static void addToolButton(KToolBar *);
  static KRQuickHelp *obj;
public slots:
  void buttonClick();
  void grabEnd();
protected:
  static QIntDict<const char> widgDict;
  static QIntDict<KRQHSlot> sigDict;
  static KToolBar *toolbar;
friend class KQHMouseGrab;
};

class KQHWnd:public KQuickHelpWindow
{
  Q_OBJECT
signals:
  void hintend();
public:
  KQHWnd() :KQuickHelpWindow() {}
  ~KQHWnd() {}
  void hide() {KQuickHelpWindow::hide(); emit hintend();}
};

class KQHMouseGrab:public QWidget
{
  Q_OBJECT
public:
  KQHMouseGrab(QWidget *parent=NULL, const char *name=0);
  virtual ~KQHMouseGrab() {}
protected:
  void endgrab();
  void mousePressEvent(QMouseEvent *e);
  KQHWnd qhwnd;
protected slots:
  void hintend();
signals:
  void grabEnd();
  void needQuickHelp(KQHWnd *w, int x, int y);
};

class KRQHEvFilter:public QObject
{
  Q_OBJECT
public:
  KRQHEvFilter();
public slots:
  void hungryQh(KQHWnd *, int x, int y);
  void hungryQh();
protected:
  QPoint curr;
  KQHWnd *qhwnd;
  bool eventFilter(QObject *, QEvent *);
};

#endif